﻿using System;
using System.Collections.Generic;

namespace Brainteasers
{
    public class BadComparer<T> : IComparer<T>
    {
        private readonly IComparer<T> original;

        public BadComparer(IComparer<T> original)
        {
            this.original = original;
        }

        public int Compare(T x, T y)
        {
            return -original.Compare(x, y);
        }
    }

    class Int32Comparer : IComparer<int>
    {
        public int Compare(int x, int y)
        {
            return x == y ? 0
                : x < y ? int.MinValue
                : int.MaxValue;
        }
    }

    class BadComparerTest
    {
        static void Main()
        {
            IComparer<int> ascending = new Int32Comparer();
            IComparer<int> descending = new BadComparer<int>(ascending);
            Console.WriteLine(descending.Compare(1, 0));
            Console.WriteLine(descending.Compare(0, 1));
        }
    }
}
