﻿using System;
using System.ComponentModel;
using System.Linq;
using MiscUtil.Linq.Extensions;

namespace ColourVoting
{
    [Description("First use of push model")]
    class FirstPushModel
    {
        static void Main()
        {
            var query = Voter.AllVoters()
                             .GroupWithPipeline(voter => voter.FavouriteColour.ToUpper(),
                                                voters => voters.Count())
                             .Select(grouped => new { Colour = grouped.Key, Votes = grouped.Value });

            foreach (var entry in query)
            {
                Console.WriteLine("Colour {0} has {1} votes", entry.Colour, entry.Votes);
            }
        }
    }
}
