﻿using System;
using System.ComponentModel;
using System.Linq;
using MiscUtil.Linq.Extensions;

namespace ColourVoting
{
    [Description("Push model retrieving voter range")]
    class FirstPushModelWithMinMaxAge
    {
        static void Main()
        {
            var query = Voter.AllVoters()
                             .GroupWithPipeline(voter => voter.FavouriteColour.ToUpper(),
                                                voters => voters.Count(),
                                                voters => voters.Min(voter => voter.Age),
                                                voters => voters.Max(voter => voter.Age))
                             .Select(grouped => new { Colour = grouped.Key, 
                                                      Votes = grouped.Value1,
                                                      MinAge = grouped.Value2,
                                                      MaxAge = grouped.Value3});

            foreach (var entry in query)
            {
                Console.WriteLine("Colour {0} has {1} votes. Age range: {2}-{3}", 
                                  entry.Colour, entry.Votes, entry.MinAge, entry.MaxAge);
            }
        }
    }
}
