﻿using System;
using System.ComponentModel;
using System.Linq;

namespace ColourVoting
{
    [Description("Using pull model but with reduced memory usage")]
    class LeanerPullModel
    {
        static void Main()
        {
            var query = from voter in Voter.AllVoters()
                        group 1 by voter.FavouriteColour.ToUpper() into grouped
                        select new { Colour = grouped.Key, Votes = grouped.Count() };

            foreach (var entry in query)
            {
                Console.WriteLine("Colour {0} has {1} votes", entry.Colour, entry.Votes);
            }
        }
    }
}
