﻿using System;
using System.ComponentModel;

using MiscUtil.Linq;
using MiscUtil.Linq.Extensions;

namespace ColourVoting
{
    [Description("Using push all the way, with a query expression")]
    class PushWithQueryExpression
    {
        static void Main()
        {
            DataProducer<Voter> voters = new DataProducer<Voter>();

            var query = from voter in voters
                        group voter by voter.FavouriteColour.ToUpper() into grouped
                        select new { Colour = grouped.Key, Votes = grouped.Count() };

            var results = query.AsEnumerable();

            voters.ProduceAndEnd(Voter.AllVoters());

            foreach (var entry in results)
            {
                Console.WriteLine("Colour {0} has {1} votes", entry.Colour, entry.Votes.Value);
            }
        }
    }
}
