﻿using System;
using System.ComponentModel;
using System.Linq;

namespace ColourVoting
{
    [Description("Initial vanilla LINQ query (pull model)")]
    class SimplePullModel
    {
        static void Main()
        {
            var query = from voter in Voter.AllVoters()
                        group voter by voter.FavouriteColour.ToUpper() into grouped
                        select new { Colour = grouped.Key, Votes = grouped.Count() };

            foreach (var entry in query)
            {
                Console.WriteLine("Colour {0} has {1} votes", entry.Colour, entry.Votes);
            }
        }
    }
}
