﻿using System;
using System.Text;
namespace Logging
{
    public partial class LogException
    {
        public static LogException FromException(Exception e)
        {
            Builder builder = CreateBuilder();
            if (e.Message != null)
            {
                builder.Message = e.Message;
            }
            if (e.StackTrace != null)
            {
                builder.StackTrace = e.StackTrace;
            }
            builder.Type = e.GetType().FullName;
            if (e.InnerException != null)
            {
                builder.NestedException = FromException(e.InnerException);
            }
            return builder.Build();
        }

        public string Format()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append(Type);
            builder.Append(":\r\n");
            builder.Append(StackTrace);
            if (HasNestedException)
            {
                builder.Append("\r\n");
                builder.Append(NestedException.Format());
            }
            return builder.ToString();
        }
    }
}
