﻿using System;
using System.IO;
using System.Linq;
using Google.ProtocolBuffers;
using Logging.Properties;

namespace Logging
{
    public class PullLinq
    {
        static void Main()
        {
            // This will fail when the logs get massive!
            string dir = Settings.Default.LogDirectory;

            /* This will do it all in one go - for sanity, I've broken it up so we
             * can just take the first 5 million records
            var query = from file in Directory.GetFiles(dir, "*.log")
                        from entry in MessageStreamIterator<LogEntry>.FromFile(Path.Combine(dir, file))
                        group 1 by entry.Severity into groups
                        select new { Severity = groups.Key, Count = groups.Count() };
            */

            var source = from file in Directory.GetFiles(dir, "*.log")
                         from entry in MessageStreamIterator<LogEntry>.FromFile(Path.Combine(dir, file))
                         select entry;

            source = source.Take(5000000);

            
            var query = from entry in source
                        group 1 by entry.Severity into groups
                        select new { Severity = groups.Key, Count = groups.Count() };
            

            foreach (var result in query)
            {
                Console.WriteLine("{0}: {1}", result.Severity, result.Count);
            }
        }
    }
}
