﻿using System;
using MiscUtil.Linq;
using MiscUtil.Linq.Extensions;

namespace ScratchPad
{
    class EvilDemo
    {
        public static int Select(Func<int, int> projection)
        {
            return 666;
        }
    }

    class CountDemo
    {
        static void Main()
        {
            var foo = from x in EvilDemo
                      select x * 2;
            Console.WriteLine(foo);

//            EvilDemo.Select(x => x * 2);

            string[] names = { "Jon", "Tom", "Holly", "William", "Robin" };
            DataProducer<string> producer = new DataProducer<string>();
            IFuture<int> count = producer.Count();
            IFuture<int> longest = producer.Max(name => name.Length);
            IFuture<int> countOfShortNames = producer.Where(name => name.Length < 4).Count();
                
                
/*                (from name in producer
                                              where name.Length < 4
                                              select name).Count();*/
            var ignored = from name in producer
                          where name.Length > 5
                          select name.ToUpper();

            ignored.DataProduced += x => Console.WriteLine("Side effect!");

            producer.ProduceAndEnd(names);

            Console.WriteLine(count.Value);
            Console.WriteLine(longest.Value);
            Console.WriteLine(countOfShortNames.Value);
        }
    }
}
